SystemOrganization addCategory: #'Pier-FileUpload-Nginx-Wysiwyg'!

PRFileUploadWysiwygEditorBase subclass: #PRFileUploadNginxWysiwygEditor
	instanceVariableNames: 'uploadComponent progressBarId notificationId uploadedFilesContainerId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-FileUpload-Nginx-Wysiwyg'!

!PRFileUploadNginxWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 8/17/2011 19:37'!
defineElementIdsOn: html
	self notificationId: html nextId.
	self progressBarId: html nextId.
	self editor textId: html nextId
	! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 8/17/2011 19:48'!
defineUploadConfiguration
	| progressBar |
	progressBar := JQueryClass new id: self progressBarId.
			
	self uploadComponent configuration
		onFileUploaded: [ :file | self storeUploadedFile: file ];
		onRenderForm: [ :html :fileUploadField :fileUploadStartJS | 
			fileUploadField onChange: fileUploadStartJS; style: 'margin-left: 5px' ]; 
		nginxUrlHook: ';fileupload';
		onBeforeUpload: (progressBar show progressbar value: 0) asFunction;
		onUploadProgress: self onUploadProgressCallback;
		onUploadError: self onUploadErrorCallback;
		onUploadResponse: ((JSStream on: ('$("#', self notificationId, '").html(renderedResponse);
			if (uploadedFile){$("#', self editor textId, '_insertimage_url").val(uploadedFile.url)}')) asFunction: #('renderedResponse' 'uploadedFile'))! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/25/2011 01:54'!
notificationId
	^ notificationId! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/25/2011 01:54'!
notificationId: anObject
	notificationId := anObject! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'file upload callback' stamp: 'NickAger 8/17/2011 19:49'!
onUploadErrorCallback
	^ '$("#', self notificationId, '").html ("<div class=''status''>" + statusText + "</div>")' asFunction: #(statusText)! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'file upload callback' stamp: 'NickAger 8/17/2011 19:49'!
onUploadProgressCallback
 ^ 
'var clearUploadProgress = function() {
	$("#', self progressBarId, '").hide();
	setUploadStatus ("");
}

var setUploadStatus = function (statusText) {
	$("#', self notificationId, '").html ("<div class=''status''>" + statusText + "</div>");
}

if (uploadStatus.state == "uploading") {
	var percentageComplete = Math.floor(uploadStatus.received * 100 / uploadStatus.size);
	$("#', self progressBarId, '").progressbar({ value: percentageComplete });
	if (uploadStatus.received !!= uploadStatus.size) {
		setUploadStatus("Uploading: " + percentageComplete + "%");
	} else {
		setUploadStatus("Uploaded: processing");
	}
}
if (uploadStatus.state == "starting") {
	setUploadStatus("Starting upload");
}
if (uploadStatus.state == "done") {
	$("#', self progressBarId, '").progressbar({ value: 100 });
	clearUploadProgress();
}' asFunction: #(uploadStatus) ! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 8/17/2011 19:45'!
progressBarId
	^ progressBarId! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'accessing' stamp: 'NickAger 7/25/2011 01:54'!
progressBarId: anObject
	progressBarId := anObject! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 7/25/2011 15:12'!
renderEditorOn: html
	self defineElementIdsOn: html.
	self defineUploadConfiguration.
	
	self renderEditorInsertImagePopupOn: html.
	super renderEditorOn: html! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'rendering' stamp: 'NickAger 8/19/2011 08:28'!
renderUploaderOn: html
	html div: [
		html render: self uploadComponent.
		(html tag: 'style') 
			attributeAt: 'type' put: 'text/css'; 
			with: '#', self progressBarId, ' .ui-widget-header {background-color: #5C9CCC}'.
		html div
			id: self progressBarId;
			style: 'margin-left:5px; margin-right:20px; height: 1em; display: none; '. "start off hidden"
	
		html div id: self notificationId ]! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'file upload callback' stamp: 'NickAger 8/19/2011 13:16'!
storeUploadedFile: file
	| destinationFilepath shellMoveFileCommand webifiedFilename |

	webifiedFilename := self webifyFilename: file filename.
	destinationFilepath := self createUploadedFilepath: webifiedFilename.
	shellMoveFileCommand := String streamContents: [:stream |
		stream 
			nextPutAll: 'mv ';
			nextPutAll: file filepath;
			nextPutAll: ' ''';
			nextPutAll: destinationFilepath;
			nextPutAll: '''' ].
		
	SpEnvironment runShellCommandString: shellMoveFileCommand.
	
	file 
		filepath: destinationFilepath;
		url: (self createUploadedUrl: webifiedFilename).
		
	self createUploadedStructure: file.
	
	^ file
! !

!PRFileUploadNginxWysiwygEditor methodsFor: 'components' stamp: 'NickAger 8/17/2011 17:26'!
uploadComponent
	^ uploadComponent ifNil: [ uploadComponent := NAFileUploadNginx new ]! !
